#ifndef pfodSMS_h
#define pfodSMS_h
/**
pfodSMS for Arduino
Base class for all pfodSMS_xxxx classes
The subclasses pfodSMS_xxx must override all the methods below

 (c)2012 Forward Computing and Control Pty. Ltd. 
 This code may be freely used for both private and commerical use.
 Provide this copyright is maintained.
*/
#include <Stream.h>

class pfodSMS : public Stream {
  public:
// The subclasses, pfodSMS_xxx, must override all the methods below
    virtual void setDebugStream(Print* out); // for pfodSMS_xxx debugging
    virtual Print* getRawDataOutput() = 0; // for pfodSMS_xxx to supply object to pfodSecurity 
                                       // (actually a pfodSMS_rawOutput object is returned)
    void _setIdleTimeout(unsigned long timeout);
    virtual size_t writeRawData(uint8_t c) = 0; // for pfodSMS_xxx, used by pfodSMS_rawOutput object
    virtual size_t write(uint8_t); // for Print
    virtual int available(); // for Stream
    virtual int read()=0; // for Stream
    virtual int peek(); // for Stream
    virtual void flush(); // for Stream
    virtual void _closeCurrentConnection();  
  	const static unsigned long DEFAULT_TIME_OUT = 600; // SEC
  protected:
  	unsigned long _idleTimeout;
};    
#endif //pfodSMS_h
